
/* -------------------------------------------------------------------
   A. Veneziani - semplice programma che definisce una classe numero
                  intero e alcune semplici operazioni su esso

                  Scritto in C++ Bulder 6
   ------------------------------------------------------------------- */               

#include <iostream>

using namespace std;

// classe che implementa un numero intero
class Intero {

   private:
   // campo privato in cui viene contenuto il numero intero dell' oggetto
   int n;

   // metodi pubblici che effettuano varie operazioni...
   public:

   // assegnazione di un valore intero all' oggetto Intero
   void assegna(int v)
   {
       n = v;
   }

   // incrementa il valore interno all'oggetto
   void incrementa()
   {
       n++;
   }

   // decrementa il valore interno all'oggetto
   void decrementa()
   {
       n--;
   }

   // calcola il valore assoluto dell'intero
   // interno all' oggetto e poi lo riassegna
   void val_ass()
   {
       if (n < 0)   n = - n;
   }

   // stampa il numero interno all'oggetto
   void stampa()
   {
       cout << n;
   }

   // somma un intero con l'intero interno all' oggetto
   // edil risultato e' riassegnato al contenuto dell' oggetto
   void somma(Intero i)
   {
       n = n + i.n;
   }

   // somma un intero con l'intero interno all' oggetto
   // ed il contenuto viene assegnato ad un altro oggetto
   Intero somma2(Intero i)
   {
       Intero altro_i;

       altro_i.n = n + i.n;

       return(altro_i);
   }
   
};


int main()
{
    Intero i, i2, r;

    // semplici operazioni di testo
    i.assegna(-5);
    i.incrementa();
    i.val_ass();

    // qui i contiene +4

    i2.assegna(10);
    i.somma(i2);

    // qui i contiene 14

    cout << "Il numero risultante dalle elaborazioni e':  ";
    i.stampa();
    cout << endl;

    i2.assegna(10);
    r = i.somma2(i2);

    // qui r contiene 24

    cout << "Il numero risultante della seconda elaborazione e':  ";
    r.stampa();

    cin.get();     // attende un carattere da cin

    return(0);
}





